MODULE CV_Server_T_v2 EXPORTS CV_Server, CV_Server_T_v2;

IMPORT Rd, Thread, Wr, CV_Server, StubLib, AtomList, NetObj;
CONST Protocol: StubLib.StubProtocol = 2;

TYPE
      Methods = {checkClockSyncNow};
      ReturnCodes = {OK, CV_Server_Error};

  PROCEDURE Surrogate_checkClockSyncNow(self: CV_Server.T)
      : CV_Server.ClockSyncReport RAISES {CV_Server.Error, NetObj.Error,
      Thread.Alerted} =

    VAR reuse := FALSE;
        rep: StubLib.DataRep;
        c: StubLib.Conn;
        dataPresent: BOOLEAN; <* NOWARN *>
        res: CV_Server.ClockSyncReport;

    BEGIN
      TRY
        c := StubLib.StartCall(self, Protocol);
        TRY
          StubLib.OutInt32(c, ORD(Methods.checkClockSyncNow));
          rep := StubLib.AwaitResult(c);
          CASE StubLib.InInt32(c, rep) OF
          | ORD(ReturnCodes.OK) =>
            res.serverDate.year := StubLib.InInteger(c, rep, 0, 2147483647);
            res.serverDate.month := VAL(StubLib.InInteger(c, rep, 0,11), Date.Month);
            res.serverDate.day := StubLib.InInteger(c, rep, 1, 31);
            res.serverDate.hour := StubLib.InInteger(c, rep, 0, 23);
            res.serverDate.minute := StubLib.InInteger(c, rep, 0, 59);
            res.serverDate.second := StubLib.InInteger(c, rep, 0, 60);
            res.serverDate.offset := StubLib.InInteger(c, rep);
            res.serverDate.zone := StubLib.InRef(c, rep, -1);
            res.serverDate.weekDay := VAL(StubLib.InInteger(c, rep, 0,6), Date.WeekDay);
            res.MATT_Date.year := StubLib.InInteger(c, rep, 0, 2147483647);
            res.MATT_Date.month := VAL(StubLib.InInteger(c, rep, 0,11), Date.Month);
            res.MATT_Date.day := StubLib.InInteger(c, rep, 1, 31);
            res.MATT_Date.hour := StubLib.InInteger(c, rep, 0, 23);
            res.MATT_Date.minute := StubLib.InInteger(c, rep, 0, 59);
            res.MATT_Date.second := StubLib.InInteger(c, rep, 0, 60);
            res.MATT_Date.offset := StubLib.InInteger(c, rep);
            res.MATT_Date.zone := StubLib.InRef(c, rep, -1);
            res.MATT_Date.weekDay := VAL(StubLib.InInteger(c, rep, 0,6), Date.WeekDay);
            res.deltaSecs := StubLib.InInteger(c, rep);
            res.timeZonesDiffer := VAL(StubLib.InInteger(c, rep, 0,1), BOOLEAN);
            reuse := TRUE;
          | ORD(ReturnCodes.CV_Server_Error) =>
            VAR arg: AtomList.T;
            BEGIN
              arg := StubLib.InRef(c, rep, TYPECODE(AtomList.T));
              reuse := TRUE;
              RAISE CV_Server.Error(arg);

            END;
          ELSE
            StubLib.RaiseUnmarshalFailure();
          END
        FINALLY
          StubLib.EndCall(c, reuse);
        END;

      EXCEPT
      | Rd.Failure(ec) => StubLib.RaiseCommFailure(ec);
      | Wr.Failure(ec) => StubLib.RaiseCommFailure(ec);
      END;
      RETURN res;
    END Surrogate_checkClockSyncNow;

PROCEDURE Invoke(
    c: StubLib.Conn;
    obj: NetObj.T;
    rep: StubLib.DataRep;
    stubProt: StubLib.StubProtocol)
    RAISES {NetObj.Error, Rd.Failure,
            Wr.Failure, Thread.Alerted} =
  VAR t := NARROW(obj, CV_Server.T);
  BEGIN
    IF stubProt # Protocol THEN StubLib.RaiseUnmarshalFailure() END;
    TRY
      CASE StubLib.InInt32(c, rep) OF
      | ORD(Methods.checkClockSyncNow) => Stub_checkClockSyncNow(t, c, rep);
      ELSE
        StubLib.RaiseUnmarshalFailure();
      END;
    EXCEPT
    | CV_Server.Error(arg) =>
        StubLib.StartResult(c);
        StubLib.OutInt32(c, ORD(ReturnCodes.CV_Server_Error));
        StubLib.OutRef(c, arg);
    END;
  END Invoke;

PROCEDURE Stub_checkClockSyncNow(
    self: CV_Server.T;
    c: StubLib.Conn;
    <* NOWARN *> rep: StubLib.DataRep) RAISES {NetObj.Error, Rd.Failure,
    Wr.Failure, Thread.Alerted, CV_Server.Error}=
  VAR res: CV_Server.ClockSyncReport;
      dataPresent: BOOLEAN <* NOWARN *>;

  BEGIN
    res := self.checkClockSyncNow();
    StubLib.StartResult(c);
    StubLib.OutInt32(c, ORD(ReturnCodes.OK));
    StubLib.OutInteger(c, res.serverDate.year);
    StubLib.OutInteger(c, ORD(res.serverDate.month));
    StubLib.OutInteger(c, res.serverDate.day);
    StubLib.OutInteger(c, res.serverDate.hour);
    StubLib.OutInteger(c, res.serverDate.minute);
    StubLib.OutInteger(c, res.serverDate.second);
    StubLib.OutInteger(c, res.serverDate.offset);
    StubLib.OutRef(c, res.serverDate.zone);
    StubLib.OutInteger(c, ORD(res.serverDate.weekDay));
    StubLib.OutInteger(c, res.MATT_Date.year);
    StubLib.OutInteger(c, ORD(res.MATT_Date.month));
    StubLib.OutInteger(c, res.MATT_Date.day);
    StubLib.OutInteger(c, res.MATT_Date.hour);
    StubLib.OutInteger(c, res.MATT_Date.minute);
    StubLib.OutInteger(c, res.MATT_Date.second);
    StubLib.OutInteger(c, res.MATT_Date.offset);
    StubLib.OutRef(c, res.MATT_Date.zone);
    StubLib.OutInteger(c, ORD(res.MATT_Date.weekDay));
    StubLib.OutInteger(c, res.deltaSecs);
    StubLib.OutInteger(c, ORD(res.timeZonesDiffer));

  END Stub_checkClockSyncNow;

BEGIN
  StubLib.Register(TYPECODE(CV_Server.T), 2, TYPECODE(Surrogate_CV_Server_T), Invoke);
END CV_Server_T_v2.
